/*
    Copyright (C) 2005-2010  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "gui.h"
#include "config_gui.h"

G_MODULE_EXPORT void
on_checkShowNotificationOnDownloadDone_toggled(GtkWidget *caller, gpointer data)
{
    ConfigGUIOpts opts;

    opts = config_gui_get_opts();
    opts.show_notification_on_file_downloaded = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(caller));
    config_gui_set_opts(opts);
}

G_MODULE_EXPORT void
on_checkShowNotificationOnFileDecoded_toggled(GtkWidget *caller, gpointer data)
{
    ConfigGUIOpts opts;

    opts = config_gui_get_opts();
    opts.show_notification_on_file_decoded = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(caller));
    config_gui_set_opts(opts);
}

void
config_notifications_initialize()
{
    GtkWidget *checkShowNotificationOnDownloadDone;
    GtkWidget *checkShowNotificationOnFileDecoded;
    ConfigGUIOpts gui_opts;

    gui_opts = config_gui_get_opts();

    checkShowNotificationOnDownloadDone = nntpgrab_gui_base_get_widget("checkShowNotificationOnDownloadDone");
    checkShowNotificationOnFileDecoded = nntpgrab_gui_base_get_widget("checkShowNotificationOnFileDecoded");

    g_signal_handlers_block_by_func (G_OBJECT (checkShowNotificationOnDownloadDone), G_CALLBACK (on_checkShowNotificationOnDownloadDone_toggled), NULL);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkShowNotificationOnDownloadDone), gui_opts.show_notification_on_file_downloaded);
    g_signal_handlers_unblock_by_func (G_OBJECT (checkShowNotificationOnDownloadDone), G_CALLBACK (on_checkShowNotificationOnDownloadDone_toggled), NULL);

    g_signal_handlers_block_by_func (G_OBJECT (checkShowNotificationOnFileDecoded), G_CALLBACK (on_checkShowNotificationOnFileDecoded_toggled), NULL);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkShowNotificationOnFileDecoded), gui_opts.show_notification_on_file_decoded);
    g_signal_handlers_unblock_by_func (G_OBJECT (checkShowNotificationOnFileDecoded), G_CALLBACK (on_checkShowNotificationOnFileDecoded_toggled), NULL);
}
