/*
    Copyright (C) 2005-2010  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "gui.h"

G_MODULE_EXPORT void
on_chkEnablePAR2Repair_toggled(GtkToggleButton *caller, gpointer data)
{
    NGConfigOpts opts = nntpgrab_glue_config_get_opts(glue);
    gboolean state = gtk_toggle_button_get_active(caller);

    if (opts.enable_par2_repair != state) {
        opts.enable_par2_repair = state;
    }

    nntpgrab_glue_config_set_opts(glue, opts);
}

G_MODULE_EXPORT void
on_chkEnableIntelligentPAR2Downloading_toggled(GtkToggleButton *caller, gpointer data)
{
    NGConfigOpts opts = nntpgrab_glue_config_get_opts(glue);
    gboolean state = gtk_toggle_button_get_active(caller);

    if (opts.enable_intelligent_par2_downloading != state) {
        opts.enable_intelligent_par2_downloading = state;
    }

    nntpgrab_glue_config_set_opts(glue, opts);
}

G_MODULE_EXPORT void
on_chkEnableAutoUnpack_toggled(GtkToggleButton *caller, gpointer data)
{
    NGConfigOpts opts = nntpgrab_glue_config_get_opts(glue);
    gboolean state = gtk_toggle_button_get_active(caller);

    if (opts.enable_auto_unpack != state) {
        opts.enable_auto_unpack = state;
    }

    nntpgrab_glue_config_set_opts(glue, opts);
 }

G_MODULE_EXPORT void
on_chkRemoveFilesAfterRepairAndUnpack_toggled(GtkToggleButton *caller, gpointer data)
{
    NGConfigOpts opts = nntpgrab_glue_config_get_opts(glue);
    gboolean state = gtk_toggle_button_get_active(caller);

    if (opts.auto_remove_files != state) {
        opts.auto_remove_files = state;
    }

    nntpgrab_glue_config_set_opts(glue, opts);
}

static void
config_changed(NntpgrabGlue *obj, gpointer data)
{
    GtkWidget *chkEnablePAR2Repair = nntpgrab_gui_base_get_widget("chkEnablePAR2Repair");
    GtkWidget *chkEnableIntelligentPAR2Downloading = nntpgrab_gui_base_get_widget("chkEnableIntelligentPAR2Downloading");
    GtkWidget *chkEnableAutoUnpack = nntpgrab_gui_base_get_widget("chkEnableAutoUnpack");
    GtkWidget *chkRemoveFilesAfterRepairAndUnpack = nntpgrab_gui_base_get_widget("chkRemoveFilesAfterRepairAndUnpack");
    NGConfigOpts opts = nntpgrab_glue_config_get_opts(glue);

    g_signal_handlers_block_by_func (G_OBJECT (chkEnablePAR2Repair), G_CALLBACK (on_chkEnablePAR2Repair_toggled), NULL);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chkEnablePAR2Repair), opts.enable_par2_repair);
    g_signal_handlers_unblock_by_func (G_OBJECT (chkEnablePAR2Repair), G_CALLBACK (on_chkEnablePAR2Repair_toggled), NULL);

    g_signal_handlers_block_by_func (G_OBJECT (chkEnableIntelligentPAR2Downloading), G_CALLBACK (on_chkEnableIntelligentPAR2Downloading_toggled), NULL);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chkEnableIntelligentPAR2Downloading), opts.enable_intelligent_par2_downloading);
    g_signal_handlers_unblock_by_func (G_OBJECT (chkEnableIntelligentPAR2Downloading), G_CALLBACK (on_chkEnableIntelligentPAR2Downloading_toggled), NULL);

    g_signal_handlers_block_by_func (G_OBJECT (chkEnableAutoUnpack), G_CALLBACK (on_chkEnableAutoUnpack_toggled), NULL);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chkEnableAutoUnpack), opts.enable_auto_unpack);
    g_signal_handlers_unblock_by_func (G_OBJECT (chkEnableAutoUnpack), G_CALLBACK (on_chkEnableAutoUnpack_toggled), NULL);

    g_signal_handlers_block_by_func (G_OBJECT (chkRemoveFilesAfterRepairAndUnpack), G_CALLBACK (on_chkRemoveFilesAfterRepairAndUnpack_toggled), NULL);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chkRemoveFilesAfterRepairAndUnpack), opts.auto_remove_files);
    g_signal_handlers_unblock_by_func (G_OBJECT (chkRemoveFilesAfterRepairAndUnpack), G_CALLBACK (on_chkRemoveFilesAfterRepairAndUnpack_toggled), NULL);
}

void
config_par2_initialize()
{
    nntpgrab_glue_signal_connect(glue, "config_changed", NG_CALLBACK(config_changed), NULL);
    config_changed(glue, NULL);
}
