#include "FormDebug.h"
#include "ui_FormDebug.h"

FormDebug::FormDebug(QNNTPGrabGlue *glue, QWidget *parent) :
    QWidget(parent),
    ui(new Ui::FormDebug)
{
    this->glue = glue;
    ui->setupUi(this);

    glue->setEmitLogMessages(true);

    connect(glue, SIGNAL(logMessage(QString,QNNTPGrabGlue::LogLevel,QString)),
                  SLOT(logMessage(QString,QNNTPGrabGlue::LogLevel,QString)));
}

FormDebug::~FormDebug()
{
    glue->setEmitLogMessages(false);

    delete ui;
}

void FormDebug::logMessage(QString component, QNNTPGrabGlue::LogLevel log_level, QString msg)
{
    Q_UNUSED(log_level);

    if (this->isHidden()) {
        return;
    }

    ui->txtDebug->append(component + QString(" - ") + msg);
}
