#ifndef WIDGETCONFIGDISPLAY_H
#define WIDGETCONFIGDISPLAY_H

#include <QWidget>
#include "ConfigGuiOpts.h"
#include "WidgetConnections.h"
#include "WidgetDownloadQueue.h"

namespace Ui {
    class WidgetConfigDisplay;
}

class MainWindow;   /* Prevent recursion */

class WidgetConfigDisplay : public QWidget {
    Q_OBJECT
public:
    WidgetConfigDisplay(WidgetConnections *widgetConnections, WidgetDownloadQueue *widgetDownloadQueue, MainWindow *mainwindow, QWidget *parent = 0);
    ~WidgetConfigDisplay();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::WidgetConfigDisplay *ui;
    ConfigGuiOpts opts;
    WidgetConnections *widgetConnections;
    WidgetDownloadQueue *widgetDownloadQueue;
    MainWindow *mainwindow;

private slots:
    void chkShowColumnProgress_toggled(bool toggled);
    void chkShowColumnSubject_toggled(bool toggled);
    void chkShowColumnPoster_toggled(bool toggled);
    void chkShowColumnNewsgroups_toggled(bool toggled);
    void chkShowColumnFileSize_toggled(bool toggled);
    void chkShowColumnFileSizeRemaining_toggled(bool toggled);
    void chkShowColumnStamp_toggled(bool toggled);
    void chkShowColumnTimeRemaining_toggled(bool toggled);
    void chkShowColumnTimeToFinish_toggled(bool toggled);

    void chkShowTrayIcon_toggled(bool toggled);
    void chkShowConnectDialog_toggled(bool toggled);
    void chkHideInactiveConnections_toggled(bool toggled);
};

#endif // WIDGETCONFIGDISPLAY_H
