#include "WidgetConfigNotifications.h"
#include "ui_WidgetConfigNotifications.h"
#include "mainwindow.h"

WidgetConfigNotifications::WidgetConfigNotifications(QNNTPGrabGlue *glue, MainWindow *mainwindow, QWidget *parent) :
    QWidget(parent),
    ui(new Ui::WidgetConfigNotifications)
{
    ui->setupUi(this);

    this->glue = glue;
    this->mainwindow = mainwindow;

    ui->chkNotificationFileDownloaded->setChecked(opts.getShowNotificationOnFileDownloaded());
    ui->chkNotificationFileDecoded->setChecked(opts.getShowNotificationOnFileDecoded());

    mainwindow->setShowNotificationOnFileDownloaded(opts.getShowNotificationOnFileDownloaded());
    mainwindow->setShowNotificationOnFileDecoded(opts.getShowNotificationOnFileDecoded());

    connect(ui->chkNotificationFileDownloaded, SIGNAL(toggled(bool)), SLOT(chkNotificationFileDownloaded_toggled(bool)));
    connect(ui->chkNotificationFileDecoded, SIGNAL(toggled(bool)), SLOT(chkNotificationFileDecoded_toggled(bool)));

    if (!QSystemTrayIcon::supportsMessages()) {
        ui->chkNotificationFileDownloaded->setEnabled(false);
        ui->chkNotificationFileDecoded->setEnabled(false);
    }
}

WidgetConfigNotifications::~WidgetConfigNotifications()
{
    delete ui;
}

void WidgetConfigNotifications::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void WidgetConfigNotifications::chkNotificationFileDownloaded_toggled(bool toggled)
{
    opts.setShowNotificationOnFileDownloaded(toggled);
    mainwindow->setShowNotificationOnFileDownloaded(toggled);
}

void WidgetConfigNotifications::chkNotificationFileDecoded_toggled(bool toggled)
{
    opts.setShowNotificationOnFileDecoded(toggled);
    mainwindow->setShowNotificationOnFileDecoded(toggled);
}
